unit Example;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComponetAny, ComCtrls, Spin, ExtCtrls, ImgList, Menus;

type
  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    SEHPos: TSpinEdit;
    SEHPage: TSpinEdit;
    PHPos: TPanel;
    PHPage: TPanel;
    SEVPos: TSpinEdit;
    SEVPage: TSpinEdit;
    PVPos: TPanel;
    PVPage: TPanel;
    ButtHVisible: TButton;
    ButtVVisible: TButton;
    VCL: TComponentAny;
    procedure FormActivate(Sender: TObject);
    procedure VCLMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure VCLMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure VCLChangeFocus(Sender: TObject; Focused: Boolean);
    procedure VCLKeyPress(Sender: TObject; var Key: Char);
    procedure VCLPaint(Sender: TObject; Canvas: TCanvas; PaintRect: TRect);
    procedure VCLKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure VCLKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure VCLHorzScrolled(Sender: TObject; var ScrollData: TScrollRec);
    procedure VCLVertScrolled(Sender: TObject; var ScrollData: TScrollRec);
    procedure ButtHVisibleClick(Sender: TObject);
    procedure ButtVVisibleClick(Sender: TObject);
    procedure SEHPosChange(Sender: TObject);
    procedure SEHPageChange(Sender: TObject);
    procedure SEVPosChange(Sender: TObject);
    procedure SEVPageChange(Sender: TObject);
  end;

var
  Form1: TForm1;
  Str: string;

implementation

{$R *.DFM}

procedure TForm1.FormActivate(Sender: TObject);
begin
 SEHPos.Value := VCL.HorzScroll.Position;
 SEVPos.Value := VCL.VertScroll.Position;
 SEHPage.Value := VCL.HorzScroll.Page;
 SEVPage.Value := VCL.VertScroll.Page;
 vcl.Focus := true;
 VCL.CaretSize(point(3,12));
 VCL.CaretMoveTo(Point(12,12));
 VCL.CaretVisible(true);
end;

procedure TForm1.VCLPaint(Sender: TObject; Canvas: TCanvas; PaintRect: TRect);
begin
 VCL.Canvas.Brush.Color := clWhite;
 VCL.Canvas.Pen.Color := clFuchsia;
 VCL.Canvas.TextOut(22,15, Str);
 VCL.CaretMoveTo(Point(VCL.Canvas.TextWidth(Str) + 22,15));

 VCL.Canvas.Brush.Color := clBtnFace;
 VCL.Canvas.TextOut(12, 55, 'This is a simple example progarm to show you what you can do with this object.');
 VCL.Canvas.TextOut(12, 68, 'Start typing in some text, and realise two events and three lines of code places the text');
 VCL.Canvas.TextOut(12, 80, 'and positions the caret in on the Canvas.');
 VCL.Canvas.TextOut(12, 92, 'you have full power of TCanvas in this work area,' +
                    ' and you have a Paint event avalible to you, that is called with invalidate. ');
 VCL.Canvas.TextOut(12, 104, 'You have full use of both scroll bars.');
 VCL.Canvas.TextOut(12, 116, 'Push ether mouse button down in this object and drag and release.');
 VCL.Canvas.TextOut(12, 128, 'most of the standard in form frames have been made avalible.');

 VCL.Canvas.Font.Style := [fsBold];
 VCL.Canvas.TextOut(12, 144, 'Writting with standard Delphi code, you can create any specialized object you like in a Delphi form!!!!');
 VCL.Canvas.Font.Style := [];
 VCL.Canvas.TextOut(12, 158, 'The support features found in OOP has been made avalible as standard Object propertys.');
 VCL.Canvas.TextOut(12, 172, 'I intend to add canvas movement control to this object a soon as i get a chance.');
 VCL.Canvas.TextOut(12, 186, 'I have not recorded Mouse lines for the Paint event to refresh them on this canvas.');
 VCL.Canvas.Pen.Width := 4;
 VCL.Canvas.Ellipse(Rect(50, 220, 450, 320));
end;

procedure TForm1.VCLChangeFocus(Sender: TObject;
  Focused: Boolean);
begin
  CheckBox1.Checked := Focused;
  vcl.CaretVisible(Focused);
end;

procedure TForm1.VCLMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 VCL.Canvas.MoveTo(x, Y);
 VCL.Focus := true;
end;

procedure TForm1.VCLMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 If mbLeft = Button then
     VCL.Canvas.Pen.Color := clblue
     else VCL.Canvas.Pen.Color := clRED;
 VCL.Canvas.LineTo(X,Y);
end;

procedure TForm1.VCLKeyPress(Sender: TObject; var Key: Char);
begin
  Str := Str + Key;
  vcl.Focus := true;
  VCl.Invalidate;
end;

procedure TForm1.VCLKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 VCL.Canvas.Brush.Color := clAqua;
 VCL.Canvas.Pen.Color := clBlack;
 VCL.Canvas.TextOut(22,35, 'key down');
end;

procedure TForm1.VCLKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 VCL.Canvas.Brush.Color := clAqua;
 VCL.Canvas.Pen.Color := clBlack;
 VCL.Canvas.TextOut(22,35, 'key up     ');
end;

procedure TForm1.VCLHorzScrolled(Sender: TObject;
  var ScrollData: TScrollRec);
begin
 PHPos.Caption := IntToStr(VCL.HorzScroll.Position);
 PHPage.Caption := IntToStr(VCL.HorzScroll.Page);
end;

procedure TForm1.VCLVertScrolled(Sender: TObject;
  var ScrollData: TScrollRec);
begin
 PVPos.Caption := IntToStr(VCL.VertScroll.Position);
 PVPage.Caption := IntToStr(VCL.VertScroll.Page);
end;

procedure TForm1.ButtVVisibleClick(Sender: TObject);
begin
  VCL.VertScroll.Visible := not VCL.VertScroll.Visible;
  VCL.ReCreateWindow;
end;

procedure TForm1.ButtHVisibleClick(Sender: TObject);
begin
  VCL.HorzScroll.Visible := not VCL.HorzScroll.Visible;
  VCL.ReCreateWindow;
end;

procedure TForm1.SEHPosChange(Sender: TObject);
begin
  VCL.HorzScroll.Position := SEHPos.Value;
  VCL.ReCreateWindow;
end;

procedure TForm1.SEHPageChange(Sender: TObject);
begin
  VCL.HorzScroll.Page := SEHPage.Value;
  VCL.ReCreateWindow;
end;

procedure TForm1.SEVPosChange(Sender: TObject);
begin
  VCL.VertScroll.Position := SEVPos.Value;
  VCL.ReCreateWindow;
end;

procedure TForm1.SEVPageChange(Sender: TObject);
begin
  VCL.VertScroll.Page := SEVPage.Value;
  VCL.ReCreateWindow;
end;

end.
